#pragma ident  "@(#)capnjoin.c	1.0 93/09/29"

/******************************************************************************/
/*                                                                            */
/*  (c) Copyright Hewlett-Packard Company, 1993, Fort Collins, Colorado       */
/*                                                                            */
/*  (C) COPYRIGHT International Business Machines Corp. 1993                  */
/*                                                                            */
/*                            All Rights Reserved                             */
/*                                                                            */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,          */
/*  provided that the above copyright notices appear in all copies and that   */
/*  both the copyright notices and this permission notice appear in           */
/*  supporting documentation, and that the name of Hewlett-Packard not be     */
/*  used in advertising or publicity pertaining to distribution of the        */
/*  software without specific, written prior permission.                      */
/*                                                                            */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS         */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/*  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable for errors contained herein or direct, indirect,      */
/*  special, incidental or consequential damages in connection with the       */
/*  furnishing, performance or use of this software.                          */
/*                                                                            */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THIS MATERIAL        */
/*  "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,        */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND FITNESS FOR A PARTICULAR PURPOSE.                                     */
/*                                                                            */
/******************************************************************************/

#include <X11/PEX5/PEXlib.h>
#include <X11/PEX5/PEXExtlib.h>
#include <misc.h>

/*
 * PEXlib Line Cap and Join Styles 
 */

draw_lines1(Display          *dpy,
	    XID              resourceID,
	    PEXOCRequestType req_type)
{
    PEXCoord	points_1[2], points_2[2], points_3[2], points_4[2], pts[4] ;
    PEXColor    area_color ;
    PEXVector   vector ;
    PEXMatrix   transform;


    /* Set up some data. */

    points_1[0].x = 0.1;
    points_1[0].y = 0.25;
    points_1[0].z = 0.0;
    points_1[1].x = 0.4;
    points_1[1].y = 0.25;
    points_1[1].z = 0.0;

    points_2[0].x = 0.25;
    points_2[0].y = 0.4;
    points_2[0].z = 0.0;
    points_2[1].x = 0.25;
    points_2[1].y = 0.1;
    points_2[1].z = 0.0;

    points_3[0].x = 0.4;
    points_3[0].y = 0.4;
    points_3[0].z = 0.0;
    points_3[1].x = 0.1;
    points_3[1].y = 0.1;
    points_3[1].z = 0.0;

    points_4[0].x = 0.1;
    points_4[0].y = 0.4;
    points_4[0].z = 0.0;
    points_4[1].x = 0.4;
    points_4[1].y = 0.1;
    points_4[1].z = 0.0;

    pts[0].x = 0.1;
    pts[0].y = 0.1;
    pts[0].z = 0.0;
    pts[1].x = 0.4;
    pts[1].y = 0.1;
    pts[1].z = 0.0;
    pts[2].x = 0.4;
    pts[2].y = 0.4;
    pts[2].z = 0.0;
    pts[3].x = 0.1;
    pts[3].y = 0.4;
    pts[3].z = 0.0;

    area_color.rgb.red = 1.0;
    area_color.rgb.green = 0.0;
    area_color.rgb.blue = 0.0;
    PEXSetSurfaceColor(dpy, resourceID, req_type,
                       PEXColorTypeRGB, &area_color);
    PEXSetInteriorStyle(dpy, resourceID, req_type, PEXInteriorStyleSolid) ;
    PEXFillArea(dpy, resourceID, req_type, PEXShapeConvex, False, 4, pts);

    PEXSetLineWidth(dpy, resourceID, req_type, 10.0);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeSolid);
    PEXPolyline(dpy, resourceID, req_type, 2, points_1);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashed);
    PEXPolyline(dpy, resourceID, req_type, 2, points_2);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDotted);
    PEXPolyline(dpy, resourceID, req_type, 2, points_3);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashDot);
    PEXPolyline(dpy, resourceID, req_type, 2, points_4);

    vector.x = 0.5 ; vector.y = 0.0 ; vector.z = 0.0 ;
    PEXTranslate(&vector, transform);
    PEXSetLocalTransform(dpy, resourceID, req_type, PEXReplace, transform);

    PEXSetSurfaceColor(dpy, resourceID, req_type,
                       PEXColorTypeRGB, &area_color);
    PEXSetInteriorStyle(dpy, resourceID, req_type, PEXInteriorStyleSolid) ;
    PEXFillArea(dpy, resourceID, req_type, PEXShapeConvex, False, 4, pts);

    PEXExtSetLineCapStyle(dpy, resourceID, req_type, PEXExtLineCapStyleButt) ;
    PEXSetLineWidth(dpy, resourceID, req_type, 10.0);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeSolid);
    PEXPolyline(dpy, resourceID, req_type, 2, points_1);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashed);
    PEXPolyline(dpy, resourceID, req_type, 2, points_2);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDotted);
    PEXPolyline(dpy, resourceID, req_type, 2, points_3);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashDot);
    PEXPolyline(dpy, resourceID, req_type, 2, points_4);

    vector.x = 0.5 ; vector.y = 0.5 ; vector.z = 0.0 ;
    PEXTranslate(&vector, transform);
    PEXSetLocalTransform(dpy, resourceID, req_type, PEXReplace, transform);

    PEXSetSurfaceColor(dpy, resourceID, req_type,
                       PEXColorTypeRGB, &area_color);
    PEXSetInteriorStyle(dpy, resourceID, req_type, PEXInteriorStyleSolid) ;
    PEXFillArea(dpy, resourceID, req_type, PEXShapeConvex, False, 4, pts);

    PEXExtSetLineCapStyle(dpy, resourceID, req_type, PEXExtLineCapStyleRound) ;
    PEXSetLineWidth(dpy, resourceID, req_type, 10.0);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeSolid);
    PEXPolyline(dpy, resourceID, req_type, 2, points_1);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashed);
    PEXPolyline(dpy, resourceID, req_type, 2, points_2);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDotted);
    PEXPolyline(dpy, resourceID, req_type, 2, points_3);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashDot);
    PEXPolyline(dpy, resourceID, req_type, 2, points_4);

    vector.x = 0.0 ; vector.y = 0.5 ; vector.z = 0.0 ;
    PEXTranslate(&vector, transform);
    PEXSetLocalTransform(dpy, resourceID, req_type, PEXReplace, transform);

    PEXSetSurfaceColor(dpy, resourceID, req_type,
                       PEXColorTypeRGB, &area_color);
    PEXSetInteriorStyle(dpy, resourceID, req_type, PEXInteriorStyleSolid) ;
    PEXFillArea(dpy, resourceID, req_type, PEXShapeConvex, False, 4, pts);

    PEXExtSetLineCapStyle(dpy, resourceID, req_type, 
                          PEXExtLineCapStyleProjecting);
    PEXSetLineWidth(dpy, resourceID, req_type, 10.0);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeSolid);
    PEXPolyline(dpy, resourceID, req_type, 2, points_1);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashed);
    PEXPolyline(dpy, resourceID, req_type, 2, points_2);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDotted);
    PEXPolyline(dpy, resourceID, req_type, 2, points_3);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashDot);
    PEXPolyline(dpy, resourceID, req_type, 2, points_4);

}

draw_curves(Display          *dpy,
	    XID              resourceID,
	    PEXOCRequestType req_type)
{
    PEXCoord         points_1[3], points_2[3], points_3[3], points_4[3], pts[4];
    PEXColor         area_color ;
    PEXVector        vector ;
    PEXMatrix        transform;
    static float     knots_3ord[] = { 1.0,1.0,2.0,3.0,4.0,4.0 };
    int              order, count, i;
    float            tmin, tmax;
    PEXArrayOfCoord  cpts;

    /* Set up some data. */

    points_1[0].x = -0.05;
    points_1[0].y = 0.25;
    points_1[0].z = 0.0;
    points_1[1].x = 0.25;
    points_1[1].y = 0.25;
    points_1[1].z = 0.0;
    points_1[2].x = 0.25;
    points_1[2].y = -0.05;
    points_1[2].z = 0.0;

    points_2[0].x = 0.25;
    points_2[0].y = 0.55;
    points_2[0].z = 0.0;
    points_2[1].x = 0.25;
    points_2[1].y = 0.25;
    points_2[1].z = 0.0;
    points_2[2].x = 0.55;
    points_2[2].y = 0.25;
    points_2[2].z = 0.0;

    points_3[0].x = 0.55;
    points_3[0].y = 0.55;
    points_3[0].z = 0.0;
    points_3[1].x = 0.25;
    points_3[1].y = 0.25;
    points_3[1].z = 0.0;
    points_3[2].x = 0.55;
    points_3[2].y = -0.05;
    points_3[2].z = 0.0;

    points_4[0].x = -0.05;
    points_4[0].y = 0.55;
    points_4[0].z = 0.0;
    points_4[1].x = 0.25;
    points_4[1].y = 0.25;
    points_4[1].z = 0.0;
    points_4[2].x = -0.05;
    points_4[2].y = -0.05;
    points_4[2].z = 0.0;

    pts[0].x = 0.1;
    pts[0].y = 0.1;
    pts[0].z = 0.0;
    pts[1].x = 0.4;
    pts[1].y = 0.1;
    pts[1].z = 0.0;
    pts[2].x = 0.4;
    pts[2].y = 0.4;
    pts[2].z = 0.0;
    pts[3].x = 0.1;
    pts[3].y = 0.4;
    pts[3].z = 0.0;

    area_color.rgb.red = 1.0;
    area_color.rgb.green = 0.0;
    area_color.rgb.blue = 0.0;
    PEXSetSurfaceColor(dpy, resourceID, req_type,
                       PEXColorTypeRGB, &area_color);
    PEXSetInteriorStyle(dpy, resourceID, req_type, PEXInteriorStyleSolid) ;
    PEXFillArea(dpy, resourceID, req_type, PEXShapeConvex, False, 4, pts);

    /*
     *      Draw the 3rd order nurb curve.
     */
    count           = 3;
    order           = 3;
    tmin            = knots_3ord[2];
    tmax            = knots_3ord[count+1];

    PEXSetLineWidth(dpy, resourceID, req_type, 10.0);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeSolid);
    cpts.point      = points_1;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashed);
    cpts.point      = points_2;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDotted);
    cpts.point      = points_3;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashDot);
    cpts.point      = points_4;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );

    vector.x = 0.5 ; vector.y = 0.0 ; vector.z = 0.0 ;
    PEXTranslate(&vector, transform);
    PEXSetLocalTransform(dpy, resourceID, req_type, PEXReplace, transform);

    PEXSetSurfaceColor(dpy, resourceID, req_type,
                       PEXColorTypeRGB, &area_color);
    PEXSetInteriorStyle(dpy, resourceID, req_type, PEXInteriorStyleSolid) ;
    PEXFillArea(dpy, resourceID, req_type, PEXShapeConvex, False, 4, pts);

    PEXExtSetLineCapStyle(dpy, resourceID, req_type, PEXExtLineCapStyleButt) ;
    PEXSetLineWidth(dpy, resourceID, req_type, 10.0);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeSolid);
    cpts.point      = points_1;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashed);
    cpts.point      = points_2;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDotted);
    cpts.point      = points_3;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashDot);
    cpts.point      = points_4;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );

    vector.x = 0.5 ; vector.y = 0.5 ; vector.z = 0.0 ;
    PEXTranslate(&vector, transform);
    PEXSetLocalTransform(dpy, resourceID, req_type, PEXReplace, transform);

    PEXSetSurfaceColor(dpy, resourceID, req_type,
                       PEXColorTypeRGB, &area_color);
    PEXSetInteriorStyle(dpy, resourceID, req_type, PEXInteriorStyleSolid) ;
    PEXFillArea(dpy, resourceID, req_type, PEXShapeConvex, False, 4, pts);

    PEXExtSetLineCapStyle(dpy, resourceID, req_type, PEXExtLineCapStyleRound) ;
    PEXSetLineWidth(dpy, resourceID, req_type, 10.0);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeSolid);
    cpts.point      = points_1;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashed);
    cpts.point      = points_2;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDotted);
    cpts.point      = points_3;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashDot);
    cpts.point      = points_4;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );

    vector.x = 0.0 ; vector.y = 0.5 ; vector.z = 0.0 ;
    PEXTranslate(&vector, transform);
    PEXSetLocalTransform(dpy, resourceID, req_type, PEXReplace, transform);

    PEXSetSurfaceColor(dpy, resourceID, req_type,
                       PEXColorTypeRGB, &area_color);
    PEXSetInteriorStyle(dpy, resourceID, req_type, PEXInteriorStyleSolid) ;
    PEXFillArea(dpy, resourceID, req_type, PEXShapeConvex, False, 4, pts);

    PEXExtSetLineCapStyle(dpy, resourceID, req_type, 
                          PEXExtLineCapStyleProjecting);
    PEXSetLineWidth(dpy, resourceID, req_type, 10.0);
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeSolid);
    cpts.point      = points_1;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashed);
    cpts.point      = points_2;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDotted);
    cpts.point      = points_3;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );
    PEXSetLineType (dpy, resourceID, req_type, PEXLineTypeDashDot);
    cpts.point      = points_4;
    PEXNURBCurve( dpy, resourceID, req_type, PEXNonRational,
                  order, knots_3ord, count, cpts, tmin, tmax );

}

draw_lines2(Display          *dpy,
	    XID              resourceID,
	    PEXOCRequestType req_type)
{
    PEXCoord	points_1[6], points_2[6], points_3[10] ;
    PEXColor    area_color ;
    PEXVector   vector ;
    PEXMatrix   transform;


    /* Set up some data. */

    points_1[0].x = 0.25;
    points_1[0].y = 0.2;
    points_1[0].z = 0.0;
    points_1[1].x = 0.3;
    points_1[1].y = 0.2;
    points_1[1].z = 0.0;
    points_1[2].x = 0.3;
    points_1[2].y = 0.3;
    points_1[2].z = 0.0;
    points_1[3].x = 0.2;
    points_1[3].y = 0.3;
    points_1[3].z = 0.0;
    points_1[4].x = 0.2;
    points_1[4].y = 0.2;
    points_1[4].z = 0.0;
    points_1[5].x = 0.25;
    points_1[5].y = 0.2;
    points_1[5].z = 0.0;

    points_2[0].x = 0.15;
    points_2[0].y = 0.15;
    points_2[0].z = 0.0;
    points_2[1].x = 0.25;
    points_2[1].y = 0.05;
    points_2[1].z = 0.0;
    points_2[2].x = 0.45;
    points_2[2].y = 0.25;
    points_2[2].z = 0.0;
    points_2[3].x = 0.25;
    points_2[3].y = 0.45;
    points_2[3].z = 0.0;
    points_2[4].x = 0.05;
    points_2[4].y = 0.25;
    points_2[4].z = 0.0;
    points_2[5].x = 0.15;
    points_2[5].y = 0.15;
    points_2[5].z = 0.0;

    points_3[0].x = 0.15;
    points_3[0].y = 0.095;
    points_3[0].z = 0.0;
    points_3[1].x = 0.25;
    points_3[1].y = 0.14;
    points_3[1].z = 0.0;
    points_3[2].x = 0.45;
    points_3[2].y = 0.05;
    points_3[2].z = 0.0;
    points_3[3].x = 0.36;
    points_3[3].y = 0.25;
    points_3[3].z = 0.0;
    points_3[4].x = 0.45;
    points_3[4].y = 0.45;
    points_3[4].z = 0.0;
    points_3[5].x = 0.25;
    points_3[5].y = 0.36;
    points_3[5].z = 0.0;
    points_3[6].x = 0.05;
    points_3[6].y = 0.45;
    points_3[6].z = 0.0;
    points_3[7].x = 0.14;
    points_3[7].y = 0.25;
    points_3[7].z = 0.0;
    points_3[8].x = 0.05;
    points_3[8].y = 0.05;
    points_3[8].z = 0.0;
    points_3[9].x = 0.15;
    points_3[9].y = 0.095;
    points_3[9].z = 0.0;

    PEXExtSetLineJoinStyle(dpy, resourceID, req_type, 
                           PEXExtLineJoinStyleImpDep) ;
    PEXSetLineWidth(dpy, resourceID, req_type, 8.0);
    PEXPolyline(dpy, resourceID, req_type, 6, points_1);
    PEXPolyline(dpy, resourceID, req_type, 6, points_2);
    PEXPolyline(dpy, resourceID, req_type, 10, points_3);

    vector.x = 0.5 ; vector.y = 0.0 ; vector.z = 0.0 ;
    PEXTranslate(&vector, transform);
    PEXSetLocalTransform(dpy, resourceID, req_type, PEXReplace, transform);

    PEXExtSetLineJoinStyle(dpy, resourceID, req_type, 
                           PEXExtLineJoinStyleRound) ;
    PEXSetLineWidth(dpy, resourceID, req_type, 8.0);
    PEXPolyline(dpy, resourceID, req_type, 6, points_1);
    PEXPolyline(dpy, resourceID, req_type, 6, points_2);
    PEXPolyline(dpy, resourceID, req_type, 10, points_3);

    vector.x = 0.5 ; vector.y = 0.5 ; vector.z = 0.0 ;
    PEXTranslate(&vector, transform);
    PEXSetLocalTransform(dpy, resourceID, req_type, PEXReplace, transform);

    PEXExtSetLineJoinStyle(dpy, resourceID, req_type, 
                           PEXExtLineJoinStyleMiter) ;
    PEXSetLineWidth(dpy, resourceID, req_type, 8.0);
    PEXPolyline(dpy, resourceID, req_type, 6, points_1);
    PEXPolyline(dpy, resourceID, req_type, 6, points_2);
    PEXPolyline(dpy, resourceID, req_type, 10, points_3);

    vector.x = 0.0 ; vector.y = 0.5 ; vector.z = 0.0 ;
    PEXTranslate(&vector, transform);
    PEXSetLocalTransform(dpy, resourceID, req_type, PEXReplace, transform);

    PEXExtSetLineJoinStyle(dpy, resourceID, req_type, 
                           PEXExtLineJoinStyleBevel);
    PEXSetLineWidth(dpy, resourceID, req_type, 8.0);
    PEXPolyline(dpy, resourceID, req_type, 6, points_1);
    PEXPolyline(dpy, resourceID, req_type, 6, points_2);
    PEXPolyline(dpy, resourceID, req_type, 10, points_3);

}

void inquire_test_params(char *test_name, 
			 int  *num_images, 
			 int  *supported_modes, 
			 char *win_title)
    {
    strcpy(test_name, "capnjoin");
    *num_images      = 3;
    *supported_modes = IMM_MODE | STR_MODE | WKS_MODE;

    strcpy(win_title, "capnjoin");
    }

void misc_setup(Display *dpy, Window window, PEXRenderer renderer,
		int cur_image)
{

}

void execute_test(Display *dpy, XID resourceID, 
	       PEXOCRequestType req_type, int cur_image)
{
    switch(cur_image) {
      case 1:
        describe_test( "PEX Line Cap and Join Styles \n" );
        describe_test( "    Image 1: Line Cap Styles - PEXPolyline \n" );
        describe_test( "\n" );
        describe_test( "  The image that you should see on the screen \n" );
        describe_test( "  contains four sets of four white lines drawn \n" );
        describe_test( "  on top of a red square. The bottom two should \n" );
        describe_test( "  have default (Butt) and Butt cap line styles. \n" );
        describe_test( "  The top left should have projecting caps and \n" );
        describe_test( "  the top right should have round caps. Each of \n" );
        describe_test( "  the four lines has a different line style.    \n" );

        draw_lines1(dpy, resourceID, req_type);
        break ;
      case 2:
        describe_test( "PEX Line Cap and Join Styles \n" );
        describe_test( "    Image 2: Line Cap Styles - PEXNURBCurve \n" );
        describe_test( "\n" );
        describe_test( "  The image that you should see on the screen \n" );
        describe_test( "  contains four sets of four white curves drawn \n" );
        describe_test( "  on top of a red square. The bottom two should \n" );
        describe_test( "  have default (Butt) and Butt cap line styles. \n" );
        describe_test( "  The top left should have projecting caps and \n" );
        describe_test( "  the top right should have round caps. Each of \n" );
        describe_test( "  the four curves has a different line style.   \n" );

        draw_curves(dpy, resourceID, req_type);
        break ;
      case 3:
        describe_test( "PEX Line Cap and Join Styles \n" );
        describe_test( "    Image 3: Line Join Styles \n" );
        describe_test( "\n" );
        describe_test( "  The image that you should see on the screen \n" );
        describe_test( "  contains four sets of white lines. \n" );
        describe_test( "  The bottom left set should be joined with an \n" );
        describe_test( "  ImpDep style. The bottom right set should be \n" );
        describe_test( "  joined with JoinStyleRound. The top left should \n" );
        describe_test( "  be joined with JoinStyleBevel and the top right \n" );
        describe_test( "  should be joined with JoinStyleMiter.\n" );

        draw_lines2(dpy, resourceID, req_type);
        break ;
    }
}

void testproc(Display *dpy, Window window, int cur_image)
    {
    char image_name[80], test_name[80];

    sprintf(image_name,"capnjoin_%d", cur_image);
    sprintf(test_name, "capnjoin_#%d", cur_image);
    image_testproc(image_name, test_name, img_desc,
		   dpy,window, 0, 0, 
		   glob_window_width, glob_window_height);
    }
